#include "lvgl/lvgl.h"
//#include "lv_drivers/display/fbdev.h"
#include "lv_drivers/display/monitor.h"
#include <unistd.h>
#include <stdio.h>

int main(void)
{
    /*LittlevGL init*/
    lv_init();

    /*Linux frame buffer device init*/
//    fbdev_init();
    monitor_init();
#define DISP_BUF_SIZE LV_HOR_RES_MAX*LV_VER_RES_MAX

    /*A small buffer for LittlevGL to draw the screen's content*/
    static lv_color_t buf[DISP_BUF_SIZE];

    /*Initialize a descriptor for the buffer*/
    static lv_disp_buf_t disp_buf;
    lv_disp_buf_init(&disp_buf, buf, NULL, DISP_BUF_SIZE);

    /*Initialize and register a display driver*/
    lv_disp_drv_t disp_drv;
    lv_disp_drv_init(&disp_drv);
    disp_drv.buffer = &disp_buf;
    disp_drv.flush_cb = monitor_flush;
    lv_disp_drv_register(&disp_drv);

//    /*Create a "Hello world!" label*/
    lv_obj_t * label = lv_gauge_create(lv_scr_act(), NULL);
static lv_color_t needle_colors[3];
    needle_colors[0] = LV_COLOR_BLUE;
    needle_colors[1] = LV_COLOR_ORANGE;
    needle_colors[2] = LV_COLOR_PURPLE;
    lv_gauge_set_needle_count(label, 1, needle_colors);
lv_obj_set_size(label, 200, 200);
lv_gauge_set_range(label, 0, 60);
//    lv_gauge_set_value(label, 1, 48);
//    lv_gauge_set_value(label, 2, 22);
lv_gauge_set_critical_value(label,52);
int lbl=7;
int sublbl=(4+1)*(lbl-1)+1;
lv_gauge_set_scale(label,300,sublbl,lbl);
//    lv_gauge_set_count(label, );
    lv_obj_align(label, NULL, LV_ALIGN_CENTER, 0, 0);
int k,m;
m=1;k=0;
lv_anim_t a;
//lv_anim_core_init();
lv_anim_init(&a);
lv_anim_set_var(&a,label);
    /*Handle LitlevGL tasks (tickless mode)*/
    while(1) {
lv_gauge_set_value(label, k, 0);
k+=m;
if(k>59||k<1)m*= -1;
        lv_tick_inc(1);
        lv_task_handler();
        usleep(5000);
printf("%3d;%3d\n",k,m);
lv_disp_flush_ready(&disp_drv);
    }
    return 0;
}

